/* REXX */
comm. = '' -- common stuff
comm._Components = .array~new
Version = '16.0.1.16'
Product = 'GE2KAP'
Manufacturer = 'Paul Higgins'
comm._base_path = 'C:\PCOMM\GE2KAP'
rc = SysFileTree(comm._base_path'\*.*','dirs',"S")
if dirs.0 =  0 then do
   say 'No directories found'
   exit
end
-- build an array of the directory entries    
drs = .array~new
TotalDirs = dirs.0
-- say 'Total Files='TotalDirs
do n = 1 to TotalDirs
   drs[n] = dirs.n
   -- say 'DEBUG0 DIRS['n']='drs[n]
end 

-- Bubble sort the drs array by the path
do until swd = 0                              /* Flag to inc switched    */
   swd = 0                                    /* indicate None switche   */
   do s = 1 to drs~items -1                   /* Do Bubble Sort          */
      m = drs~at(s)                           /* get the item in array  */
      parse var m date time size attrib var1
      -- var1 = var1~lower
      g = s + 1                               /* Get the next item  */ 
      n = drs~at(g)                          /* get the next directory */
      parse var n date time size attrib var2
      -- var2 = var2~lower
      -- say 'VAR1='var1' VAR2='var2
      rc = var1~caselessCompareTo(var2)
      if rc = 1 then do                  /*  if next is lower then...*/
         -- say 'BEBUG SWITCHED'                                
         save = m                            /* Switch them around     */
         drs[s] = n                                 
         drs[g] = save                                          
         swd = 1                              /* Indicate switched       */
      end                                                           
   end                                                                 
end

do n = 1 to TotalDirs
   -- say 'DIRS['n']='drs[n]
end 

-- create first node in tree
tree = buildDirectoryDetails(comm._base_path)

-- build a tree of directories
ret = getDirectoryTree(tree, drs)

-- rc = printWindowTree(tree,'')

-- check there are no unprocessed items
fnderr = .false
do n = 1 to drs~items
   data = drs[n]
   parse var data date time size attrib path
   path = path~strip
   if date <> 'done' then do
      say 'ERROR: UNPROCESSED line:'n' ='drs[n]
      fnderr = .true
   end
end

if fnderr then exit

comm._output = .array~new
comm._output[1] = "<?xml version='1.0' encoding='windows-1252'?>"
comm._output[2] = "<Wix xmlns='http://schemas.microsoft.com/wix/2006/wi'>"
comm._output[3] = "   <Product Id='*' Name='"Product "V"Version"' Language='1033' Codepage='1252'"
comm._output[4] = "       Version='"Version"' Manufacturer='"Manufacturer"' UpgradeCode='"GetGUID()"'>"
comm._output[5] = "       <Package Id='*'  Keywords='Installer' Description='"Product" Installer' SummaryCodepage='1252'"
comm._output[6] = "           Comments='This is the "Product" installer package.' Manufacturer='"Manufacturer"' InstallerVersion='200' Compressed='yes' InstallScope='perMachine' />"
comm._output[7] = "       <MajorUpgrade DowngradeErrorMessage='A newer version of [ProductName] is already installed.' />"
comm._output[8] = "       <MediaTemplate EmbedCab='yes' />"
comm._output[9] = "       <Property Id='DISABLEADVTSHORTCUTS' Value='1' />"
comm._output[10] = "      <Feature Id='Complete' Title='"GE2KAP"' Description='The complete package.'"
comm._output[11] = "         Display='expand' Level='1' ConfigurableDirectory='INSTALLFOLDER'>"  
comm._output[12] = "           <ComponentGroupRef Id='ProductComponents' />"
comm._output[13] = "           <ComponentGroupRef Id='Shortcuts' />"

-- Add the rest of the component Groups 
str_ln = 14
dir_tree = tree~children[1] -- bypass first node
ln = AddComponentGroups(dir_tree,str_ln)
-- say 'STR_LN='str_ln' END LN='ln
-- add the rest of the Product
comm._output[ln+1] = "      </Feature>" 
comm._output[ln+2] = "      <UI>"
comm._output[ln+3] = "          <UIRef Id='WixUI_FeatureTree' />"                                                              
comm._output[ln+4] = "          <Publish Dialog='ExitDialog'"  
comm._output[ln+5] = "              Control='Finish'" 
comm._output[ln+6] = "              Event='DoAction'" 
comm._output[ln+7] = "              Value='LaunchApplication'>WIXUI_EXITDIALOGOPTIONALCHECKBOX = 1 and NOT Installed</Publish>"
comm._output[ln+8] = "      </UI>"
comm._output[ln+9] = "      <Property Id='WIXUI_EXITDIALOGOPTIONALCHECKBOXTEXT' Value='Launch GE2KAP' />"
comm._output[ln+10] = "      <Property Id='WIXUI_EXITDIALOGOPTIONALCHECKBOX' Value='1' />"
comm._output[ln+11] = "      <Property Id='WixShellExecTarget' Value='[#"Product".exe]' />"
comm._output[ln+12] = "      <CustomAction Id='LaunchApplication'" 
comm._output[ln+13] = "          BinaryKey='WixCA'" 
comm._output[ln+14] = "          DllEntry='WixShellExec'"
comm._output[ln+15] = "          Impersonate='yes' />"         
comm._output[ln+16] = "   </Product>" 
comm._output[ln+17] = " " 
comm._output[ln+18] = "   <Fragment>"
comm._output[ln+19] = "      <Directory Id='TARGETDIR' Name='SourceDir'>"
comm._output[ln+20] = "         <Directory ComponentGuidGenerationSeed='{"GetGuid()"}'  Id='WINDOWSVOLUME'>"
comm._output[ln+21] = "            <Directory Id='ge2kap' Name='GE2KAP'>"
comm._output[ln+22] = "               <Directory Id='INSTALLFOLDER' Name='"Product".V"Version"'>"

-- add all the directories starting at the second one
str_ln = ln + 23
dir_tree = tree~children[1] -- bypass first node
ln = AddDirectoryTree(dir_tree,'                  ',str_ln)
-- say 'STR_LN='str_ln' END LN='ln
ln += 1
comm._output[ln] = "               </Directory>"
comm._output[ln+1] = "            </Directory>"
comm._output[ln+2] = "         </Directory>"
comm._output[ln+3] = "         <Directory Id='ProgramMenuFolder' Name='Programs'>"
comm._output[ln+4] = "            <Directory Id='ProgramMenuDir' Name='"Product"' />"
comm._output[ln+5] = "         </Directory>"
comm._output[ln+6] = "          <Directory Id='DesktopFolder' Name='Desktop' />"
comm._output[ln+7] = "      </Directory>"
comm._output[ln+8] = "      <SetDirectory Id='WINDOWSVOLUME' Value='[WindowsVolume]'/>"
comm._output[ln+9] = "   </Fragment>"

comm._output[ln+10] = " "

comm._output[ln+11] = "   <Fragment>"
comm._output[ln+12] = "       <ComponentGroup Id='ProductComponents' Directory='INSTALLFOLDER'>"
comm._output[ln+13] = "           <Component Id='MainExecutable' Guid='{"GetGuid()"}'> "
comm._output[ln+14] = "               <File Id='GE2KAP.exe' Name='GE2KAP.exe' KeyPath='yes' > " 
comm._output[ln+15] = "                   <Shortcut Id='startmenu"Product".V"Version"' Directory='ProgramMenuDir' Name='"Product".V"Version"' WorkingDirectory='INSTALLFOLDER' Icon='GE2KAP.exe' Advertise='yes' />"
comm._output[ln+16] = "                   <Shortcut Id='desktop"Product".V"Version"' Directory='DesktopFolder' Name='"Product".V"Version"' WorkingDirectory='INSTALLFOLDER' Icon='GE2KAP.exe'  Advertise='yes'/>"
comm._output[ln+17] = "               </File>"
comm._output[ln+18] = "           </Component>"

-- add all the components in the main product
ln = ln + 19
do n = 1 to tree~files~items
   filenm = tree~files[n]  -- get the file name
   file_id = translate(filenm,"_cnue__"," &-")  -- change french and espanol characters to English ones and blanks, & and - to underscores
   component_id = 'CMP_'file_id
   -- if the file id is numeric add a prefix
   first_char = substr(file_id,1,1)
   if datatype(first_char) = 'NUM' then 
      file_id = 'N_'||file_id   
   comm._output[ln] = "           <Component Id='"component_id"'"
   comm._output[ln+1] = "              Guid='{"GetGuid()"}'>"
   comm._output[ln+2] = "              <File Id='"file_id"'"
   comm._output[ln+3] = "              Source='"comm._base_path"\"filenm"'"   
   comm._output[ln+4] = "              KeyPath='yes'"
   comm._output[ln+5] = "              Vital='yes'/>"
   comm._output[ln+6] = "           </Component>"
   ln += 8
end 
comm._output[ln] = "      </ComponentGroup>"              
comm._output[ln+1] = "      <ComponentGroup Id='Shortcuts' Directory='ProgramMenuDir'>"
comm._output[ln+2] = "          <Component Id='ProgramMenuShortcut'>"
comm._output[ln+3] = "              <RemoveFolder Id='ProgramMenuDir' On='uninstall' />"
comm._output[ln+4] = "              <RegistryValue Root='HKCU' Key='Software\[Manufacturer]\[ProductName]' Type='string' Value='' KeyPath='yes' />"
comm._output[ln+5] = "          </Component>"
comm._output[ln+6] = "      </ComponentGroup>"
comm._output[ln+7] = "   </Fragment>"

-- add the rest of the components
str_ln = ln + 8
dir_tree = tree~children[1] -- bypass first node
ln = AddComponentTree(dir_tree,str_ln)
-- say 'STR_LN='str_ln' END LN='ln
ln += 1

comm._output[ln] = "   <Fragment>"
comm._output[ln+1] = "       <Icon Id='GE2KAP.exe' SourceFile='.\GE2KAP.ico' /> "
comm._output[ln+2] = "       <Property Id='ARPPRODUCTICON' Value='GE2KAP.exe' />"   
comm._output[ln+3] = "   </Fragment>"

comm._output[ln+4] = "</Wix>"
 
 -- write out the comm._output
do line over comm._output
   say line
end

exit

/*---------------------------------------------------------------------------*/
-- ::routine GetDirectoryTree public
GetDirectoryTree: procedure expose comm.
/*---------------------------------------------------------------------------*/ 
use arg tree,drs

-- tree = buildDirectoryDetails(path)

-- See if there are any sub (child) directories
level = countstr('~',tree~id) + 1  -- number of underscores to look for
-- say 'HERE1 LEVEL='level' NODE='tree~id
do n = 1 to drs~items
   data = drs[n]
   parse var data date time size attrib path
   path = path~strip
   -- if its the right level could be a child node
   if countstr('\', path) = level then do
      -- check if its a directory 
      if date <> 'done' then do   
         if pos('D', attrib) <> 0 then do
            -- say 'HERE2 NODE='tree~id' PATH='path
            node = buildDirectoryDetails(path)  -- create a node for it
            if tree~id~compareTo(node~id,1,length(tree~id)) = 0 then do
               -- say 'HERE3 NODE='node~id
               -- tree~children = .array~new
               tree~hasChildren = .true
               -- drs[n] = left('',length(path)) -- blank out the name of this one so we don't use again
               drs[n] = 'done' time size attrib path  -- mark as done  we don't use again
               tree~childrenCount += 1
               tree~children~append(node)
               -- say 'HERE4 NAME='tree~id' CHILDREN='tree~children~items' childrenCount='tree~childrenCount
               -- comm._Components~append(node~id) -- add as a component
               ret = getDirectoryTree(node,drs)
            end
         end 
         else do -- its a file add it to the file list
         
            -- Create dummy ID
            dir_id = ''
            strpos = 1
            pos = pos('\',path) -- find first \
            do while pos <> 0
               qualif = substr(path,strpos,pos - strpos)
               dir_id = dir_id||qualif'~'
               strpos = pos + 1
               pos = pos('\',path,strpos) -- find next \
            end
            dir_id = dir_id~strip('T','~')
            dir_id = translate(dir_id,"~~cnue",": ") -- change colons and blanks to ~
            dir_id = changestr('~~', dir_id, '~') -- eliminate any double underscores
                            
            -- say 'HERE5 PATH='path' DIR_ID='dir_id' TREE_ID='tree~id
            -- if this starts off the same as the tree node then its a file that belongs here
            -- if substr(dir_id,1,length(tree~id))= tree~id then do  
            if tree~id~compareTo(dir_id,1,length(tree~id)) = 0 then do    
               name = filespec('N',path)~strip
               if name <> '' then do
                  tree~files~append(name)
                  -- say 'HERE6 NAME='name' FILE COOUNT='tree~files~items
                  drs[n] = 'done' time size attrib path  -- mark as processed
               end
            end
         end               
      end
   end
end

return tree

/*---------------------------------------------------------------------------*/
--::routine buildDirectoryDetails public
buildDirectoryDetails: procedure expose comm.
/*---------------------------------------------------------------------------*/
use arg path
-- use the path as the directory name
dir_name = filespec('L',path)
dir_name = changestr('\',dir_name,'~')  -- change all the back slashes to tildes
last_qualif = filespec('N',path)
dir_name = dir_name||last_qualif

path = path'\' add a deleimiter at the end so we pickup last qualifier
-- Create directory ID
dir_id = ''
strpos = 1
pos = pos('\',path) -- find first \
do while pos <> 0
   qualif = substr(path,strpos,pos - strpos)
   dir_id = dir_id||qualif'~'
   strpos = pos + 1
   pos = pos('\',path,strpos) -- find next \
end
dir_id = dir_id~strip('T','~')
dir_id = translate(dir_id,"~~cnue",": ") -- change colons and blanks to ~
dir_id = changestr('~~', dir_id, '~') -- eliminate any ~

d = .directory~new
d~id = dir_id           -- directory id
d~name = dir_name       -- directory name
d~children = .array~new -- child directories
d~hasChildren = .false
d~childrenCount = 0
d~files = .array~new -- files in this directory

-- say 'DETAILS: ID='d~id'  '

return d

/*---------------------------------------------------------------------------*/
printWindowTree: procedure expose comm.
/*---------------------------------------------------------------------------*/
use arg tree, indent

-- A little defensive programming.. if tree is not a directory then forget it
if \ tree~isA(.directory) then return .false

-- say 'HERE1 ID='tree~id

line = indent||tree~id' Name:'tree~name

say line

-- print any files
if tree~files~items <> 0 then do
   file_indent = indent||'    '   
   do n = 1 to tree~files~items
      say file_indent||tree~files[n]  
   end
end

if tree~childrenCount == 0 then do
   -- line = line "no children"
   -- say line
   return .false
end

indent = indent||"    "

do n = 1 to tree~children~items
   child = tree~children[n]
   -- say 'HERE2 ID='child~id
   ret = printWindowTree(child, indent)
end
   
return .true

/*---------------------------------------------------------------------------*/
AddDirectoryTree: procedure expose comm.
-- adds all the directory tree to the comm._output
-- on input the tree points to second tree node
/*---------------------------------------------------------------------------*/
use arg tree, indent, ln

-- A little defensive programming.. if tree is not a directory then forget it
if \ tree~isA(.directory) then return .false

-- Example of tree~name on input: C:~PCOMM~GE2KAP~Help~Franais~Exemples_KML_KMZ_GPX
tree_name = tree~name
pos = lastpos('~',tree_name)
last_qualif = substr(tree_name,pos+1)
line = indent||"<Directory Id='"tree~id"' Name='"last_qualif"'>"
line = translate(line, '__','~-')    -- remove invalid characters

comm._output[ln] = line
ln += 1

if tree~childrenCount == 0 then do
   -- line = line "no children"
   -- say line
   line = indent||"</Directory>"
   comm._output[ln] = line
   ln += 1
   return ln
end

indent = indent||"   "
do n = 1 to tree~children~items
   child = tree~children[n]
   -- say 'HERE2 ID='child~id
   ln = AddDirectoryTree(child, indent,ln)
end

ll = length(indent)
indent = left('',ll - 3)
line = indent||"</Directory>"
comm._output[ln] = line
ln += 1
   
return ln

/*---------------------------------------------------------------------------*/
AddComponentTree: procedure expose comm.
-- adds all the components except first
-- on input the tree points to second tree node
/*---------------------------------------------------------------------------*/
use arg tree,ln

-- A little defensive programming.. if tree is not a directory then forget it
if \ tree~isA(.directory) then return .false

-- say 'DEBUG ID='tree~id' LN='ln  


tree_id = tree~id
parse var tree_id '~' . '~' . '~' qualif
qualif = changestr('~',qualif,'\')~strip 
tree_id = translate(tree_id,'__','~-') 
-- C~PCOMM~GE2KAP~Help~Francais~Exemples_KML_KMZ_GPX

-- Example of tree~name on input: C:~PCOMM~GE2KAP~Help~Franais~Exemples_KML_KMZ_GPX
-- tree_name = translate(tree~id,'\','~') -- change the tildes to back slashes
tree_name = changestr('~',tree~name,'\') -- change the tildes to back slashes


comm._output[ln] = "   <Fragment>"
-- change french and espanol characters to English ones and blanks,~, & and - to underscores
componentgrp_id = translate(tree_id,"_cnue___"," &-~") 
comm._output[ln+1] = "       <ComponentGroup Id='"componentgrp_id"' Directory='"tree_id"'>"

if tree~files~items > 0 then do
   do n = 1 to tree~files~items
      filenm = tree~files[n]  -- get the file name
      guid = GetGUID()
      guid_id = changestr('-',guid,'_') -- change the dashes to underscores
      component_id = 'CMP_'guid_id~upper
      file_id = 'FILE_'guid_id~upper

      comm._output[ln+3] = "           <Component Id='"component_id"'"
      comm._output[ln+4] = "              Guid='{"guid"}'>"
      comm._output[ln+5] = "              <File Id='"file_id"'"
      comm._output[ln+6] = "              Source='"tree_name"\"filenm"'"
      comm._output[ln+7] = "              KeyPath='yes'"
      comm._output[ln+8] = "              Vital='yes'/>"
      comm._output[ln+9] = "           </Component>"
      ln += 10
   end 
   comm._output[ln] = "      </ComponentGroup>"              
   comm._output[ln+1] = "   </Fragment>"
   ln += 2
end   

if tree~childrenCount == 0 then do
   return ln
end

-- do all the kids
do n = 1 to tree~children~items
   child = tree~children[n]
   -- say 'HERE2 ID='child~id
   ln = AddComponentTree(child,ln)
end
   
return ln

/*---------------------------------------------------------------------------*/
AddComponentGroups: procedure expose comm.
-- adds all the component groups into the Product
-- on input the tree points to second tree node
/*---------------------------------------------------------------------------*/
use arg tree,ln

-- A little defensive programming.. if tree is not a directory then forget it
if \ tree~isA(.directory) then return .false

-- say 'DEBUG ID='tree~id' LN='ln  

tree_id = tree~id
parse var tree_id '~' . '~' . '~' qualif
qualif = changestr('~',qualif,'\')~strip 
tree_id = translate(tree_id,'__','~-') 
-- C~PCOMM~GE2KAP~Help~Francais~Exemples_KML_KMZ_GPX

if tree~files~items > 0 then do
   componentgrp_id = translate(tree_id,"_cnue___"," &-~") -- change french and espanol characters to English ones and blanks,~, & and - to underscores
   comm._output[ln] = "           <ComponentGroupRef Id='"componentgrp_id"' />"
   ln += 1
end   

if tree~childrenCount == 0 then do
   return ln
end

-- do all the kids
do n = 1 to tree~children~items
   child = tree~children[n]
   -- say 'HERE2 ID='child~id
   ln = AddComponentGroups(child,ln)
end
   
return ln
/*---------------------------------------------------------------------------*/                        
GetGUID: procedure expose comm. -- -- function to return a GUID
/*---------------------------------------------------------------------------*/
uuid_time_low = Random(0, 65535)~d2x(4)||Random(0, 65535)~d2x(4) -- 4 bytes

uuid_time_mid = Random(0, 65535)~d2x(4)  -- 2 bytes

uuid_time_hi_and_version = Random(0, 65535) 
uuid_time_hi_and_version = uuid_time_hi_and_version~d2x(4)  -- 2 bytes
--Set the four most significant bits (bits 12 through 15) of the
-- time_hi_and_version field to 4
uuid_time_hi_and_version = uuid_time_hi_and_version~x2b                                     
uuid_time_hi_and_version = bitand(uuid_time_hi_and_version,'0000111111111111')                                       
uuid_time_hi_and_version = bitor(uuid_time_hi_and_version,'0100000000000000')
uuid_time_hi_and_version = uuid_time_hi_and_version~b2x

uuid_clock_seq_hi_and_rsv = Random(0, 255)
-- Set the two most significant bits (bits 6 and 7) of the
-- clock_seq_hi_and_rsv to zero and one, respectively. 
uuid_clock_seq_hi_and_rsv = uuid_clock_seq_hi_and_rsv~d2x(2)~x2b
uuid_clock_seq_hi_and_rsv = bitand(uuid_clock_seq_hi_and_rsv,'00111111')
uuid_clock_seq_hi_and_rsv = bitor(uuid_clock_seq_hi_and_rsv,'10000000')
uuid_clock_seq_hi_and_rsv = uuid_clock_seq_hi_and_rsv~b2x

uuid_clock_seq_low = Random(0, 255)~d2x(2)

uuid_node_hi = Random(0, 65535)~d2x(4)
uuid_node_low = Random(0, 65535)~d2x(4)||Random(0, 65535)~d2x(4)

str = uuid_time_low'-'uuid_time_mid'-'uuid_time_hi_and_version'-'uuid_clock_seq_hi_and_rsv||uuid_clock_seq_low'-'uuid_node_hi||uuid_node_low 
return str~lower

